Index: code/branches/output/src/libraries/network/Client.cc
===================================================================
--- code/branches/output/src/libraries/network/Client.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/Client.cc	(revision 8788)
@@ -44,5 +44,5 @@
 
 #include "util/Clock.h"
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "util/ScopedSingletonManager.h"
 #include "synchronisable/Synchronisable.h"
Index: code/branches/output/src/libraries/network/ClientConnection.cc
===================================================================
--- code/branches/output/src/libraries/network/ClientConnection.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/ClientConnection.cc	(revision 8788)
@@ -32,5 +32,5 @@
 #define WIN32_LEAN_AND_MEAN
 #include <enet/enet.h>
-#include "util/Debug.h"
+#include "util/Output.h"
 
 namespace orxonox
Index: code/branches/output/src/libraries/network/GamestateManager.cc
===================================================================
--- code/branches/output/src/libraries/network/GamestateManager.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/GamestateManager.cc	(revision 8788)
@@ -52,5 +52,5 @@
 #include "core/command/Executor.h"
 #include "core/GameMode.h"
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "util/Clock.h"
 #include "util/OrxAssert.h"
Index: code/branches/output/src/libraries/network/LANDiscoverable.cc
===================================================================
--- code/branches/output/src/libraries/network/LANDiscoverable.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/LANDiscoverable.cc	(revision 8788)
@@ -33,5 +33,5 @@
 #include <cstring>
 
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "packet/ServerInformation.h"
 
Index: code/branches/output/src/libraries/network/MasterServerComm.cc
===================================================================
--- code/branches/output/src/libraries/network/MasterServerComm.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/MasterServerComm.cc	(revision 8788)
@@ -28,5 +28,5 @@
 
 #include "MasterServerComm.h"
-#include "util/Debug.h"
+#include "util/Output.h"
 
 namespace orxonox
Index: code/branches/output/src/libraries/network/NetworkPrecompiledHeaders.h
===================================================================
--- code/branches/output/src/libraries/network/NetworkPrecompiledHeaders.h	(revision 8739)
+++ code/branches/output/src/libraries/network/NetworkPrecompiledHeaders.h	(revision 8788)
@@ -52,5 +52,5 @@
 #include <set>      // 20
 
-#include "util/Debug.h"      // 20
+#include "util/Output.h"      // 20
 #include <loki/TypeTraits.h> // 18
 
Index: code/branches/output/src/libraries/network/Server.cc
===================================================================
--- code/branches/output/src/libraries/network/Server.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/Server.cc	(revision 8788)
@@ -47,5 +47,5 @@
 
 #include "util/Clock.h"
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "core/ObjectList.h"
 #include "core/command/Executor.h"
Index: code/branches/output/src/libraries/network/ServerConnection.cc
===================================================================
--- code/branches/output/src/libraries/network/ServerConnection.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/ServerConnection.cc	(revision 8788)
@@ -34,5 +34,5 @@
 #include <enet/enet.h>
 
-#include "util/Debug.h"
+#include "util/Output.h"
 #include <util/Sleep.h>
 // #include "ClientInformation.h"
Index: code/branches/output/src/libraries/network/packet/Acknowledgement.cc
===================================================================
--- code/branches/output/src/libraries/network/packet/Acknowledgement.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/packet/Acknowledgement.cc	(revision 8788)
@@ -29,5 +29,5 @@
 #include "Acknowledgement.h"
 
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "network/GamestateHandler.h"
 #include "network/Host.h"
Index: code/branches/output/src/libraries/network/packet/DeleteObjects.cc
===================================================================
--- code/branches/output/src/libraries/network/packet/DeleteObjects.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/packet/DeleteObjects.cc	(revision 8788)
@@ -31,5 +31,5 @@
 
 #include <cassert>
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "network/synchronisable/Synchronisable.h"
 
Index: code/branches/output/src/libraries/network/packet/FunctionIDs.cc
===================================================================
--- code/branches/output/src/libraries/network/packet/FunctionIDs.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/packet/FunctionIDs.cc	(revision 8788)
@@ -34,5 +34,5 @@
 #include <string>
 
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "core/ObjectList.h"
 #include "network/NetworkFunction.h"
Index: code/branches/output/src/libraries/network/packet/Gamestate.cc
===================================================================
--- code/branches/output/src/libraries/network/packet/Gamestate.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/packet/Gamestate.cc	(revision 8788)
@@ -31,5 +31,5 @@
 #include <zlib.h>
 
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "util/OrxAssert.h"
 #include "core/GameMode.h"
Index: code/branches/output/src/libraries/network/packet/Packet.cc
===================================================================
--- code/branches/output/src/libraries/network/packet/Packet.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/packet/Packet.cc	(revision 8788)
@@ -37,5 +37,5 @@
 #include <boost/thread/mutex.hpp>
 
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "Acknowledgement.h"
 #include "Chat.h"
Index: code/branches/output/src/libraries/network/packet/Welcome.cc
===================================================================
--- code/branches/output/src/libraries/network/packet/Welcome.cc	(revision 8739)
+++ code/branches/output/src/libraries/network/packet/Welcome.cc	(revision 8788)
@@ -32,5 +32,5 @@
 
 #include <cassert>
-#include "util/Debug.h"
+#include "util/Output.h"
 #include "network/Host.h"
 #include "network/synchronisable/Synchronisable.h"