Index: code/branches/output/data/levels/templates/FPS.oxt
===================================================================
--- code/branches/output/data/levels/templates/FPS.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/FPS.oxt	(revision 8820)
@@ -30,5 +30,5 @@
     
     <?lua
-	include("includes/weaponSettingsFPS.oxi")
+	include("../includes/weaponSettingsFPS.oxi")
     ?>
 
Index: code/branches/output/data/levels/templates/spaceshipAssff.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipAssff.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipAssff.oxt	(revision 8820)
@@ -56,5 +56,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsAssff.oxi")
+  include("../includes/weaponSettingsAssff.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipAssff2.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipAssff2.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipAssff2.oxt	(revision 8820)
@@ -56,5 +56,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsAssff2.oxi")
+  include("../includes/weaponSettingsAssff2.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipGhost.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipGhost.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipGhost.oxt	(revision 8820)
@@ -36,5 +36,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsGhost.oxi")
+  include("../includes/weaponSettingsGhost.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipH2.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipH2.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipH2.oxt	(revision 8820)
@@ -22,5 +22,5 @@
 
 <?lua
-  include("includes/weaponSettingsH2.oxi")
+  include("../includes/weaponSettingsH2.oxi")
 ?>
     <engines>
Index: code/branches/output/data/levels/templates/spaceshipHXY.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipHXY.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipHXY.oxt	(revision 8820)
@@ -37,5 +37,5 @@
 
 <?lua
-  include("includes/weaponSettingsHXY.oxi")
+  include("../includes/weaponSettingsHXY.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipHXYSL.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipHXYSL.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipHXYSL.oxt	(revision 8820)
@@ -36,5 +36,5 @@
 
 <?lua
-  include("includes/weaponSettingsHXY.oxi")
+  include("../includes/weaponSettingsHXY.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipImmTest.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipImmTest.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipImmTest.oxt	(revision 8820)
@@ -37,5 +37,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsImmTest.oxi")
+  include("../includes/weaponSettingsImmTest.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipPirate.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipPirate.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipPirate.oxt	(revision 8820)
@@ -40,5 +40,5 @@
 
 <?lua
-  include("includes/weaponSettingsPirate.oxi")
+  include("../includes/weaponSettingsPirate.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipSwallow.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipSwallow.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipSwallow.oxt	(revision 8820)
@@ -35,5 +35,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsSwallow.oxi")
+  include("../includes/weaponSettingsSwallow.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipTransporter.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipTransporter.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipTransporter.oxt	(revision 8820)
@@ -36,5 +36,5 @@
 
 <?lua
-  include("includes/weaponSettingsTransporter.oxi")
+  include("../includes/weaponSettingsTransporter.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipTransporterSL.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipTransporterSL.oxt	(revision 8739)
+++ code/branches/output/data/levels/templates/spaceshipTransporterSL.oxt	(revision 8820)
@@ -36,5 +36,5 @@
 
 <?lua
-  include("includes/weaponSettingsTransporter.oxi")
+  include("../includes/weaponSettingsTransporter.oxi")
 ?>
   </SpaceShip>