Index: code/branches/output/src/orxonox/gametypes/Asteroids.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/Asteroids.cc	(revision 8820)
+++ code/branches/output/src/orxonox/gametypes/Asteroids.cc	(revision 8822)
@@ -74,5 +74,4 @@
 
         std::string message("The match has started! Reach the first chekpoint within 15 seconds! But be aware, there may be pirates around...");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
 
@@ -84,5 +83,4 @@
 
         std::string message("The match has ended.");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
Index: code/branches/output/src/orxonox/gametypes/Deathmatch.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/Deathmatch.cc	(revision 8820)
+++ code/branches/output/src/orxonox/gametypes/Deathmatch.cc	(revision 8822)
@@ -48,5 +48,4 @@
 
         std::string message("The match has started!");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
@@ -57,5 +56,4 @@
 
         std::string message("The match has ended.");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
@@ -66,5 +64,4 @@
 
         const std::string& message = player->getName() + " entered the game";
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
@@ -77,5 +74,4 @@
         {
             const std::string& message = player->getName() + " left the game";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -91,5 +87,4 @@
         {
             const std::string& message = player->getOldName() + " changed name to " + player->getName();
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -113,5 +108,4 @@
                 message = victim->getPlayer()->getName() + " died";
 
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -127,5 +121,4 @@
         {
             const std::string& message = player->getName() + " scores!";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
Index: code/branches/output/src/orxonox/gametypes/Dynamicmatch.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8820)
+++ code/branches/output/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8822)
@@ -343,5 +343,4 @@
         Gametype::playerEntered(player);
         const std::string& message = player->getName() + " entered the game";
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
@@ -359,5 +358,4 @@
             }
             const std::string& message = player->getName() + " left the game";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
             //remove player from map
@@ -617,5 +615,4 @@
         {
             const std::string& message = player->getOldName() + " changed name to " + player->getName();
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -630,5 +627,4 @@
         {
             std::string message("Dynamicmatch started!");
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -647,5 +643,4 @@
     {
         std::string message("Earn points:\n\n\n\tIf you're red: Chase the blue player!\n\n\tIf you're blue shoot at a red player or hide.\n\n\tIf you're green: You've got the licence to kill red players!");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
         callInstructions_.setTimer(10, false, createExecutor(createFunctor(&Dynamicmatch::furtherInstructions, this)));
@@ -655,5 +650,4 @@
     {
         std::string message("After 3 Minutes the game is over.");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }*/
@@ -663,5 +657,4 @@
 
         std::string message("Time out. Press F2 to see the points you scored.");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
Index: code/branches/output/src/orxonox/gametypes/LastManStanding.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/LastManStanding.cc	(revision 8820)
+++ code/branches/output/src/orxonox/gametypes/LastManStanding.cc	(revision 8822)
@@ -90,5 +90,5 @@
                 const std::string& message = ""; // resets Camper-Warning-message
                 this->gtinfo_->sendFadingMessage(message,it->first->getClientID());
-            }    
+            }
         }
         return true;
@@ -105,5 +105,4 @@
             this->playersAlive--;
             const std::string& message = victim->getPlayer()->getName() + " has lost all lives";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -128,5 +127,5 @@
     {
         Gametype::end();
-        
+
         for (std::map<PlayerInfo*, int>::iterator it = this->playerLives_.begin(); it != this->playerLives_.end(); ++it)
         {
@@ -148,5 +147,5 @@
             return 0;
     }
-    
+
     int LastManStanding::getNumPlayersAlive() const
     {
@@ -190,5 +189,5 @@
         this->timeToAct_[player]=timeRemaining+3.0f+respawnDelay;//reset timer
         this->playerDelayTime_[player]=respawnDelay;
-        
+
         std::map<PlayerInfo*, Player>::iterator it = this->players_.find(player);
         if (it != this->players_.end())
@@ -198,5 +197,5 @@
             const std::string& message = ""; // resets Camper-Warning-message
             this->gtinfo_->sendFadingMessage(message,it->first->getClientID());
-        }  
+        }
     }
 
@@ -239,9 +238,9 @@
             }
             for (std::map<PlayerInfo*, float>::iterator it = this->timeToAct_.begin(); it != this->timeToAct_.end(); ++it)
-            {   
+            {
                 if (playerGetLives(it->first)<=0)//Players without lives shouldn't be affected by time.
-                    continue;     
+                    continue;
                 it->second-=dt;//Decreases punishment time.
-                if (!inGame_[it->first])//Manages respawn delay - player is forced to respawn after the delaytime is used up. 
+                if (!inGame_[it->first])//Manages respawn delay - player is forced to respawn after the delaytime is used up.
                 {
                     playerDelayTime_[it->first]-=dt;
Index: code/branches/output/src/orxonox/gametypes/LastTeamStanding.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/LastTeamStanding.cc	(revision 8820)
+++ code/branches/output/src/orxonox/gametypes/LastTeamStanding.cc	(revision 8822)
@@ -119,5 +119,4 @@
                 this->teamsAlive--;
             const std::string& message = victim->getPlayer()->getName() + " has lost all lives";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
Index: code/branches/output/src/orxonox/gametypes/UnderAttack.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/UnderAttack.cc	(revision 8820)
+++ code/branches/output/src/orxonox/gametypes/UnderAttack.cc	(revision 8822)
@@ -70,5 +70,4 @@
         this->end(); //end gametype
         std::string message("Ship destroyed! Team 0 has won!");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
         this->gameEnded_ = true;
@@ -153,5 +152,4 @@
                 this->end();
                 std::string message("Time is up! Team 1 has won!");
-                orxout(level::message) << message << endl;
                 Host::Broadcast(message);
 
@@ -173,5 +171,4 @@
                 const std::string& message = multi_cast<std::string>(timesequence_) + " seconds left!";
 /*
-                orxout(level::message) << message << endl;
                 Host::Broadcast(message);
 */