Index: code/trunk/src/modules/pickup/Pickup.cc
===================================================================
--- code/trunk/src/modules/pickup/Pickup.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/Pickup.cc	(revision 8858)
@@ -169,5 +169,5 @@
         else
         {
-            COUT(1) << "Invalid activationType '" << type << "' in pickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid activationType '" << type << "' in pickup." << endl;
         }
     }
@@ -191,5 +191,5 @@
         else
         {
-            COUT(1) << "Invalid durationType '" << type << "' in pickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid durationType '" << type << "' in pickup." << endl;
         }
     }
Index: code/trunk/src/modules/pickup/PickupManager.cc
===================================================================
--- code/trunk/src/modules/pickup/PickupManager.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/PickupManager.cc	(revision 8858)
@@ -72,5 +72,5 @@
         this->defaultRepresentation_ = new PickupRepresentation();
 
-        COUT(3) << "PickupManager created." << std::endl;
+        orxout(internal_info, context::pickups) << "PickupManager created." << endl;
     }
 
@@ -101,5 +101,5 @@
         this->indexes_.clear();
 
-        COUT(3) << "PickupManager destroyed." << std::endl;
+        orxout(internal_info, context::pickups) << "PickupManager destroyed." << endl;
     }
 
@@ -126,5 +126,5 @@
         this->representations_[identifier] = representation;
 
-        COUT(4) << "PickupRepresentation &" << representation << " registered with the PickupManager." << std::endl;
+        orxout(verbose, context::pickups) << "PickupRepresentation &" << representation << " registered with the PickupManager." << endl;
         return true;
     }
@@ -151,5 +151,5 @@
         this->representations_.erase(it);
 
-        COUT(4) << "PickupRepresentation &" << representation << " unregistered with the PickupManager." << std::endl;
+        orxout(verbose, context::pickups) << "PickupRepresentation &" << representation << " unregistered with the PickupManager." << endl;
         return true;
     }
@@ -208,5 +208,5 @@
         if(it == this->representations_.end()) // If there is no PickupRepresentation associated with the input PickupIdentifier.
         {
-            COUT(4) << "PickupManager::getRepresentation() returned default representation." << std::endl;
+            orxout(verbose, context::pickups) << "PickupManager::getRepresentation() returned default representation." << endl;
             return this->defaultRepresentation_;
         }
@@ -284,5 +284,5 @@
         if(manager.pickupInventoryContainers_.find(pickup) == manager.pickupInventoryContainers_.end())
         {
-            COUT(1) << "Error: Pickupable &(" << pickup << ") was not registered with PickupManager for the PickupInventory, when it changed used." << std::endl;
+            orxout(internal_error, context::pickups) << "Pickupable &(" << pickup << ") was not registered with PickupManager for the PickupInventory, when it changed used." << endl;
             return;
         }
Index: code/trunk/src/modules/pickup/PickupRepresentation.cc
===================================================================
--- code/trunk/src/modules/pickup/PickupRepresentation.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/PickupRepresentation.cc	(revision 8858)
@@ -140,5 +140,5 @@
             this->spawnerRepresentation_->setVisible(false);
 
-        COUT(4) << "PickupRepresentation created: name: '" << this->name_ << "', description: '" << this->description_ << "', spawnerTemplate: '" << this->spawnerTemplate_ << "'." << std::endl;
+        orxout(verbose, context::pickups) << "PickupRepresentation created: name: '" << this->name_ << "', description: '" << this->description_ << "', spawnerTemplate: '" << this->spawnerTemplate_ << "'." << endl;
     }
 
@@ -155,8 +155,8 @@
         if(this->spawnerRepresentation_ == NULL)
         {
-            COUT(4) << "PickupRepresentation: No spawner representation found." << std::endl;
+            orxout(verbose, context::pickups) << "PickupRepresentation: No spawner representation found." << endl;
             if(this->spawnerTemplate_ == "")
             {
-                COUT(4) << "PickupRepresentation: Spawner template is empty." << std::endl;
+                orxout(verbose, context::pickups) << "PickupRepresentation: Spawner template is empty." << endl;
                 // If neither spawnerRepresentation nor spawnerTemplate was specified
                 return this->getDefaultSpawnerRepresentation(spawner);
Index: code/trunk/src/modules/pickup/PickupSpawner.cc
===================================================================
--- code/trunk/src/modules/pickup/PickupSpawner.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/PickupSpawner.cc	(revision 8858)
@@ -90,5 +90,5 @@
         if(this->pickup_ == NULL)
         {
-            COUT(2) << "A PickupSpawner was created without a valid Pickupable. This won't work." << std::endl;
+            orxout(internal_warning, context::pickups) << "A PickupSpawner was created without a valid Pickupable. This won't work." << endl;
             this->setActive(false);
         }
@@ -144,5 +144,5 @@
         if(this->pickup_ == NULL)
         {
-            COUT(2) << "A PickupSpawner was created without a valid Pickupable. This won't work." << std::endl;
+            orxout(internal_warning, context::pickups) << "A PickupSpawner was created without a valid Pickupable. This won't work." << endl;
             this->setActive(false);
         }
@@ -239,5 +239,5 @@
         else
         {
-            COUT(4) << "PickupSpawner (&" << this << ") empty, selfdestruct initialized." << std::endl;
+            orxout(verbose, context::pickups) << "PickupSpawner (&" << this << ") empty, selfdestruct initialized." << endl;
             this->setActive(false);
             this->destroy();
@@ -264,10 +264,10 @@
         if(this->pickup_ != NULL)
         {
-            COUT(1) << "In PickupSpawner (&" << this << "): setPickupable called, with this->pickup_ already set." << std::endl;
+            orxout(internal_error, context::pickups) << "In PickupSpawner (&" << this << "): setPickupable called, with this->pickup_ already set." << endl;
             return;
         }
         if(pickup == NULL)
         {
-            COUT(1) << "In PickupSpawner (&" << this << "): Argument of setPickupable is NULL." << std::endl;
+            orxout(internal_error, context::pickups) << "In PickupSpawner (&" << this << "): Argument of setPickupable is NULL." << endl;
             return;
         }
@@ -298,5 +298,5 @@
         if(this->isActive()) // Checks whether PickupSpawner is active.
         {
-            COUT(4) << "PickupSpawner (&" << this << ") triggered and active." << std::endl;
+            orxout(verbose, context::pickups) << "PickupSpawner (&" << this << ") triggered and active." << endl;
 
             PickupCarrier* carrier = dynamic_cast<PickupCarrier*>(pawn);
@@ -306,5 +306,5 @@
             if(!carrier->isTarget(this->pickup_))
             {
-                COUT(4) << "PickupSpawner (&" << this << ") triggered but Pawn wasn't a target of the Pickupable." << std::endl;
+                orxout(verbose, context::pickups) << "PickupSpawner (&" << this << ") triggered but Pawn wasn't a target of the Pickupable." << endl;
                 return;
             }
@@ -335,5 +335,5 @@
         if(this->spawnsRemaining_ == 0)
         {
-            COUT(1) << "Massive Error: PickupSpawner still alive until having spawned last item." << std::endl;
+            orxout(internal_error, context::pickups) << "Massive Error: PickupSpawner still alive until having spawned last item." << endl;
             return NULL;
         }
@@ -349,5 +349,5 @@
     void PickupSpawner::respawnTimerCallback()
     {
-        COUT(4) << "PickupSpawner (&" << this << ") reactivated." << std::endl;
+        orxout(verbose, context::pickups) << "PickupSpawner (&" << this << ") reactivated." << endl;
 
         this->setActive(true);
Index: code/trunk/src/modules/pickup/items/DronePickup.cc
===================================================================
--- code/trunk/src/modules/pickup/items/DronePickup.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/items/DronePickup.cc	(revision 8858)
@@ -179,5 +179,5 @@
         if(pawn == NULL)
         {
-            COUT(1) << "Invalid PickupCarrier in DronePickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid PickupCarrier in DronePickup." << endl;
         }
 
Index: code/trunk/src/modules/pickup/items/HealthPickup.cc
===================================================================
--- code/trunk/src/modules/pickup/items/HealthPickup.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/items/HealthPickup.cc	(revision 8858)
@@ -169,5 +169,5 @@
                     break;
                 default:
-                    COUT(1) << "Invalid healthType in HealthPickup." << std::endl;
+                    orxout(internal_error, context::pickups) << "Invalid healthType in HealthPickup." << endl;
             }
 
@@ -218,5 +218,5 @@
                         break;
                     default:
-                        COUT(1) << "Invalid healthType in HealthPickup." << std::endl;
+                        orxout(internal_error, context::pickups) << "Invalid healthType in HealthPickup." << endl;
                 }
 
@@ -234,5 +234,5 @@
                 if(pawn == NULL)
                 {
-                    COUT(1) << "Something went horribly wrong in Health Pickup. PickupCarrier is no Pawn." << std::endl;
+                    orxout(internal_error, context::pickups) << "Something went horribly wrong in Health Pickup. PickupCarrier is no Pawn." << endl;
                     this->Pickupable::destroy();
                     return;
@@ -268,5 +268,5 @@
         if(pawn == NULL)
         {
-            COUT(1) << "Invalid PickupCarrier in HealthPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid PickupCarrier in HealthPickup." << endl;
         }
 
@@ -312,5 +312,5 @@
                 return HealthPickup::healthTypePermanent_s;
             default:
-                COUT(1) << "Invalid healthType in HealthPickup." << std::endl;
+                orxout(internal_error, context::pickups) << "Invalid healthType in HealthPickup." << endl;
                 return BLANKSTRING;
         }
@@ -331,5 +331,5 @@
         else
         {
-            COUT(1) << "Invalid health in HealthPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid health in HealthPickup." << endl;
             this->health_ = 0.0;
         }
@@ -350,5 +350,5 @@
         else
         {
-            COUT(1) << "Invalid healthSpeed in HealthPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid healthSpeed in HealthPickup." << endl;
         }
     }
@@ -376,5 +376,5 @@
         else
         {
-            COUT(1) << "Invalid healthType in HealthPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid healthType in HealthPickup." << endl;
         }
     }
Index: code/trunk/src/modules/pickup/items/InvisiblePickup.cc
===================================================================
--- code/trunk/src/modules/pickup/items/InvisiblePickup.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/items/InvisiblePickup.cc	(revision 8858)
@@ -206,5 +206,5 @@
         if(pawn == NULL)
         {
-            COUT(1) << "Invalid PickupCarrier in InvisiblePickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid PickupCarrier in InvisiblePickup." << endl;
         }
         return pawn;
@@ -225,5 +225,5 @@
         else
         {
-            COUT(1) << "Invalid duration in InvisiblePickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid duration in InvisiblePickup." << endl;
             this->duration_ = 0.0f;
         }
Index: code/trunk/src/modules/pickup/items/MetaPickup.cc
===================================================================
--- code/trunk/src/modules/pickup/items/MetaPickup.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/items/MetaPickup.cc	(revision 8858)
@@ -232,5 +232,5 @@
         }
         else
-            COUT(2) << "Invalid metaType '" << type << "' in MetaPickup." << std::endl;
+            orxout(internal_warning, context::pickups) << "Invalid metaType '" << type << "' in MetaPickup." << endl;
     }
 
Index: code/trunk/src/modules/pickup/items/ShieldPickup.cc
===================================================================
--- code/trunk/src/modules/pickup/items/ShieldPickup.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/items/ShieldPickup.cc	(revision 8858)
@@ -181,5 +181,5 @@
         if(pawn == NULL)
         {
-            COUT(1) << "Invalid PickupCarrier in ShieldPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid PickupCarrier in ShieldPickup." << endl;
         }
         return pawn;
@@ -220,5 +220,5 @@
         else
         {
-            COUT(1) << "Invalid duration in ShieldPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid duration in ShieldPickup." << endl;
             this->duration_ = 0.0f;
         }
@@ -239,5 +239,5 @@
         else
         {
-            COUT(1) << "Invalid Shieldhealth in ShieldPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid Shieldhealth in ShieldPickup." << endl;
             this->shieldHealth_=0;
         }
@@ -258,5 +258,5 @@
         else
         {
-            COUT(1) << "Invalid Absorption in ShieldPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid Absorption in ShieldPickup." << endl;
             this->shieldAbsorption_=0;
         }
Index: code/trunk/src/modules/pickup/items/ShrinkPickup.h
===================================================================
--- code/trunk/src/modules/pickup/items/ShrinkPickup.h	(revision 8729)
+++ code/trunk/src/modules/pickup/items/ShrinkPickup.h	(revision 8858)
@@ -93,5 +93,5 @@
             */
             inline void setShrinkFactor(float factor)
-                { if(factor <= 1.0f) { COUT(2) << "Invalid shrinking factor in ShrinkPickup. Ignoring.." << endl; return; } this->shrinkFactor_ = factor; }
+                { if(factor <= 1.0f) { orxout(internal_warning, context::pickups) << "Invalid shrinking factor in ShrinkPickup. Ignoring.." << endl; return; } this->shrinkFactor_ = factor; }
             /**
             @brief Get the duration for which the ship remains shrunken.
@@ -105,5 +105,5 @@
             */
             inline void setDuration(float duration)
-                { if(duration < 0.0f) { COUT(2) << "Invalid duration in ShrinkPickup. Ignoring.." << endl; return; } this->duration_ = duration; }
+                { if(duration < 0.0f) { orxout(internal_warning, context::pickups) << "Invalid duration in ShrinkPickup. Ignoring.." << endl; return; } this->duration_ = duration; }
             /**
             @brief Get the shrink speed.
@@ -117,5 +117,5 @@
             */
             inline void setShrinkDuration(float speed)
-                { if(speed <= 0.0f) { COUT(2) << "Invalid shrink duration in ShrinkPickup. Ignoring.." << endl; return; } this->shrinkDuration_ = speed; }
+                { if(speed <= 0.0f) { orxout(internal_warning, context::pickups) << "Invalid shrink duration in ShrinkPickup. Ignoring.." << endl; return; } this->shrinkDuration_ = speed; }
 
         protected:
Index: code/trunk/src/modules/pickup/items/SpeedPickup.cc
===================================================================
--- code/trunk/src/modules/pickup/items/SpeedPickup.cc	(revision 8729)
+++ code/trunk/src/modules/pickup/items/SpeedPickup.cc	(revision 8858)
@@ -180,5 +180,5 @@
         if(ship == NULL)
         {
-            COUT(1) << "Invalid PickupCarrier in SpeedPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid PickupCarrier in SpeedPickup." << endl;
         }
 
@@ -221,5 +221,5 @@
         else
         {
-            COUT(1) << "Invalid duration in SpeedPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid duration in SpeedPickup." << endl;
             this->duration_ = 0.0f;
         }
@@ -240,5 +240,5 @@
         else
         {
-            COUT(1) << "Invalid speedAdd in SpeedPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid speedAdd in SpeedPickup." << endl;
             this->speedAdd_ = 0.0f;
         }
@@ -259,5 +259,5 @@
         else
         {
-            COUT(1) << "Invalid speedMultiply in SpeedPickup." << std::endl;
+            orxout(internal_error, context::pickups) << "Invalid speedMultiply in SpeedPickup." << endl;
             this->speedMultiply_ = 1.0f;
         }